/***
*
* BNBT Beta 8.0 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 Trevor Hogan
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// =Xotic= Modified Source File

#include "bnbt.h"
#include "atom.h"
#include "tracker.h"
#include "util.h"

// Added by =Xotic=
#include "xconfig_lang.h"
// --------------------- End of Addition


void CTracker :: serverResponseSignup( struct request_t *pRequest, struct response_t *pResponse )
{
	struct bnbttv btv = UTIL_CurrentTime( );

	// Added by =Xotic=
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
	// XBNBT MySQL Users Integration
	if( giMySQLUsersOverrideUsers )
	{
		// redirect
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["signup_page"], string( CSS_SIGNUP ), string( m_strForumLink ), NOT_INDEX, CODE_200 );
	}
	// --------------------------------------- End of Addition
	else
	{
#endif
		if( pRequest->user.iAccess & ACCESS_SIGNUP )
		{
			HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["signup_page"], string( CSS_SIGNUP ), string( ), NOT_INDEX, CODE_200 );

			if( pRequest->mapParams.find( "us_login" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_password" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_password_verify" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_email" ) != pRequest->mapParams.end( ) )
			{
				string strLogin = pRequest->mapParams["us_login"];
				string strPass = pRequest->mapParams["us_password"];
				string strPass2 = pRequest->mapParams["us_password_verify"];
				string strMail = pRequest->mapParams["us_email"];

				if( strLogin.empty( ) || strPass.empty( ) || strPass2.empty( ) || strMail.empty( ) )
				{
					// Modififed by =Xotic=
					//Unable to signup. You must fill in all the fields.
					pResponse->strContent += "<p class=\"signup_failed\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_fields_error"].c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/signup.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
					// ---------------------- End of Modification

					return;
				}
				else
				{
					if( strLogin[0] == ' ' || strLogin[strLogin.size( ) - 1] == ' ' || strLogin.size( ) > (unsigned int)m_iNameLength )
					{
						// Modified by =Xotic=	
						// Unable to signup. Your name must be less than " + CAtomInt( m_iNameLength ).toString( ) + " characters long and it must not start or end with spaces.
						pResponse->strContent += "<p class=\"signup_failed\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_name_error"].c_str( ), CAtomInt( m_iNameLength ).toString( ).c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/signup.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

						// Output common HTML ending
						HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
						// ---------------------- End of Modification

						return;
					}

					if( strMail.find( "@" ) == string :: npos || strMail.find( "." ) == string :: npos )
					{
						// Modified by =Xotic=
						// Unable to signup. Your e-mail address is invalid.
						pResponse->strContent += "<p class=\"signup_failed\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_email_error"].c_str( ), CAtomInt( m_iNameLength ).toString( ).c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/signup.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

						// Output common HTML ending
						HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
						// ---------------------- End of Modification

						return;
					}

					if( strPass == strPass2 )
					{
						if( m_pUsers->getItem( strLogin ) )
						{
							// Modified by =Xotic=	
							// Unable to signup. The user \"" + UTIL_RemoveHTML( strLogin ) + "\" already exists.
							pResponse->strContent += "<p class=\"signup_failed\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_exists_error"].c_str( ), UTIL_RemoveHTML( strLogin ).c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/signup.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

							// Output common HTML ending
							HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
							// ---------------------- End of Modification

							return;
						}
						else
						{
							addUser( strLogin, strPass, m_iMemberAccess, strMail );

							// Modified by =Xotic=	
							// Thanks! You've successfully signed up!
							pResponse->strContent += "<p class=\"signup_ok\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_success"].c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/login.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

							// Output common HTML ending
							HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
							// ---------------------- End of Modification

							return;
						}
					}
					else
					{
						// Modified by =Xotic=	
						// Unable to signup. The passwords did not match.
						pResponse->strContent += "<p class=\"signup_failed\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_password_error"].c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_signup"] + "\" href=\"/signup.html\">" ).c_str( ), "</a>" ) + "</p>\n\n";

						// Output common HTML ending
						HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
						// ---------------------- End of Modification

						return;
					}
				}
			}
			pResponse->strContent += "<div class=\"signup_form\">\n";
			pResponse->strContent += "<table class=\"signup_form\">\n";
			pResponse->strContent += "<tr>\n";
			pResponse->strContent += "<td>\n";
			pResponse->strContent += "<form name=\"us_details\" method=\"get\" action=\"/signup.html\">\n";
			pResponse->strContent += "<p class=\"signup_form_header\">" + gmapLANG_CFG["signup"] + "</p>\n";
			pResponse->strContent += "<ul>\n";

			// Names must be less than %s characters long
			pResponse->strContent += "<li class=\"signup\">" + UTIL_Xsprintf( gmapLANG_CFG["signup_info_name_length"].c_str( ), CAtomInt( m_iNameLength ).toString( ).c_str( ) ) + "</li>\n";

			pResponse->strContent += "<li class=\"signup\">" + gmapLANG_CFG["signup_info_case"] + "</li>\n";
			pResponse->strContent += "<li class=\"signup\">" + gmapLANG_CFG["no_html"] + "</li>\n";
			pResponse->strContent += "</ul>\n";
			pResponse->strContent += "<p class=\"signup_form\"><input id=\"login\" name=\"us_login\" alt=\"[" + gmapLANG_CFG["login"] + "]\" type=text size=24 maxlength=" + CAtomInt( m_iNameLength ).toString( ) + "> <label for=\"login\">" + gmapLANG_CFG["login"] + "</label></p>\n";
			pResponse->strContent += "<p class=\"signup_form\"><input id=\"password\" name=\"us_password\" alt=\"[" + gmapLANG_CFG["password"] + "]\" type=password size=20> <label for=\"password\">" + gmapLANG_CFG["password"] + "</label></p>\n";
			pResponse->strContent += "<p class=\"signup_form\"><input id=\"verify\" name=\"us_password_verify\" alt=\"[" + gmapLANG_CFG["verify_password"] + "]\" type=password size=20> <label for=\"verify\">" + gmapLANG_CFG["verify_password"] + "</label></p>\n";
			pResponse->strContent += "<p class=\"signup_form\"><input id=\"email\" name=\"us_email\" alt=\"[" + gmapLANG_CFG["email"] + "]\" type=text size=40> <label for=\"email\">" + gmapLANG_CFG["email"] + "</label></p>\n";
			pResponse->strContent += "<p class=\"signup_form_button\">";
			Button_Submit( "submit_signup", string( gmapLANG_CFG["signup"] ), pResponse );
			pResponse->strContent += "</p>\n";
			pResponse->strContent += "</form>\n";
			pResponse->strContent += "</td>\n";
			pResponse->strContent += "</tr>\n";
			pResponse->strContent += "</table>\n";
			pResponse->strContent += "</div>\n\n";
		}
		else
			HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["signup_page"], string( CSS_SIGNUP ), string( ), NOT_INDEX, CODE_401 );

	// Added by =Xotic=
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
	// XBNBT MySQL Users Integration
	}
#endif
	HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_SIGNUP ) );
	// ---------------------------------- End of Addition
}
